;;;; -*- Mode: LISP; Syntax: ANSI-Common-Lisp; Base: 10 -*-
;;;;
;;;; CMUCL 19a Patch 001: Fix a bug in make-instance reported by Axel
;;;; Schairer, cmucl-help, 2004-08-05.


(pushnew :cmucl-19a-patch-001 *features*)

(in-package "PCL")


#+(and cmu19a (not cmucl-19a-patch-001))
(ext:without-package-locks
(defun quote-plist-keys (plist)
  (loop for (key . more) on plist by #'cddr
	if (null more) do
	  (error "Not a property list: ~S" plist)
	else
	  collect `(quote ,key)
     and collect (car more)))
)

#+(and cmu19a (not cmucl-19a-patch-001))
(ext:without-package-locks
(defun fake-initialization-emf (ctor ii-methods si-methods)
  (multiple-value-bind (ii-around ii-before ii-primary ii-after)
      (standard-sort-methods ii-methods)
    (declare (ignore ii-primary))
    (multiple-value-bind (si-around si-before si-primary si-after)
	(standard-sort-methods si-methods)
      (declare (ignore si-primary))
      (assert (and (null ii-around) (null si-around)))
      (let ((initargs (ctor-initargs ctor))
	    (slot-inits (slot-init-forms ctor (or ii-before si-before))))
	(flet ((method-calls (methods args)
		 (loop for method in methods
		       as fn = (method-function method)
		       collect `(funcall (truly-the function ,fn) ,args ()))))
	  (values
	   `(let (,@(when (or ii-before ii-after)
		    `((.ii-args.
		       (list .instance. ,@(quote-plist-keys initargs)))))
		  ,@(when (or si-before si-after)
		    `((.si-args.
		       (list .instance. t ,@(quote-plist-keys initargs))))))
	      ,@(method-calls ii-before '.ii-args.)
	      ,@(method-calls si-before '.si-args.)
	      ,slot-inits
	      ,@(method-calls si-after '.si-args.)
	      ,@(method-calls ii-after '.ii-args.))
	   (or ii-before si-before)))))))
)
